package cn.com.infosec.util.test;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.security.SecureRandom;

public class FixedSecureRandom extends SecureRandom {
   private byte[] _data;
   private int _index;
   private int _intPad;

   public FixedSecureRandom(byte[] value) {
      FixedSecureRandom var10000 = this;
      byte[][] var2;
      (var2 = new byte[1][])[0] = value;
      var10000.<init>(false, var2);
   }

   public FixedSecureRandom(byte[][] values) {
      this(false, values);
   }

   public FixedSecureRandom(boolean intPad, byte[] value) {
      FixedSecureRandom var10000 = this;
      byte[][] var3;
      (var3 = new byte[1][])[0] = value;
      var10000.<init>(intPad, var3);
   }

   public FixedSecureRandom(boolean intPad, byte[][] values) {
      ByteArrayOutputStream var3;
      var3 = new ByteArrayOutputStream.<init>();

      for(int var4 = 0; var4 != values.length; ++var4) {
         try {
            var3.write(values[var4]);
         } catch (IOException var5) {
            throw new IllegalArgumentException("can't save value array.");
         }
      }

      byte[] intPad1;
      this._data = intPad1 = var3.toByteArray();
      if (intPad) {
         this._intPad = intPad1.length % 4;
      }

   }

   private int nextValue() {
      byte[] var10000 = this._data;
      int var1;
      this._index = (var1 = this._index) + 1;
      return var10000[var1] & 255;
   }

   public void nextBytes(byte[] bytes) {
      FixedSecureRandom var10000 = this;
      FixedSecureRandom var10001 = this;
      byte[] var10002 = this._data;
      int var3 = this._index;
      int var2 = bytes.length;
      System.arraycopy(var10002, var3, bytes, 0, var2);
      var10000._index = var10001._index + bytes.length;
   }

   public int nextInt() {
      int var1 = this.nextValue() << 24 | 0 | this.nextValue() << 16;
      int var2;
      if ((var2 = this._intPad) == 2) {
         this._intPad = var2 - 1;
      } else {
         var1 |= this.nextValue() << 8;
      }

      if ((var2 = this._intPad) == 1) {
         this._intPad = var2 - 1;
      } else {
         var1 |= this.nextValue();
      }

      return var1;
   }

   public long nextLong() {
      return (long)this.nextValue() << 56 | 0L | (long)this.nextValue() << 48 | (long)this.nextValue() << 40 | (long)this.nextValue() << 32 | (long)this.nextValue() << 24 | (long)this.nextValue() << 16 | (long)this.nextValue() << 8 | (long)this.nextValue();
   }

   public boolean isExhausted() {
      return this._index == this._data.length;
   }
}
